/*
 * Copyright (C) 2013 Darth Affe <http://wyrez.org> and contributors
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */
package org.wyrez.shootingstars.states;

import com.jme3.app.state.AppState;
import com.jme3.app.state.AppStateManager;
import org.wyrez.persij.PersiJContainer;

/**
 *
 * @author Darth Affe
 */
public class StateManager {

    private PersiJContainer container;
    private AppStateManager appStateManager;

    public StateManager(PersiJContainer container, AppStateManager appStateManager) {
        this.container = container;
        this.appStateManager = appStateManager;
    }

    public void setState(State state) {
        State.setState(state);
        appStateManager.detach(getState(State.getPreviousState()));
        appStateManager.attach(getState(State.getState()));
    }

    public <T extends AppState> T getState(State state) {
        Class clazz = state.getClazz();
        if (clazz == null) {
            return null;
        }
        if (!container.isTypeRegistered(clazz)) {
            container.registerType(clazz, true);
        }
        return (T) container.resolve(clazz);
    }
}
